var scene = new cc.Scene();

var root = new cc.Node();
var canvas = root.addComponent(cc.Canvas);
root.parent = scene;

const pgName = 'background';
function createProgressBar () {
    // load prefab
    cc.loader.loadRes(pgName, cc.Prefab, (error, res) => {
        if (!error) {
            let node = cc.instantiate(res);
            node.parent = root;
            let fill = node.getChildByName('progressBar').getComponent(cc.Component);
            loadSceneRes(fill);
        }
    });
}

function loadSceneRes (fill) {
    const sceneName = scene._launchScene;
    if (!sceneName) {
        cc.error('can\'t find launch scene.');
        return;
    }
    let curLength, maxLength = 0;

    var onProgress = function (current, total, obj) {
        maxLength = (current / total).toFixed(2);
    };

    let id = setInterval(() => {
        if (curLength < maxLength) {
            curLength += 0.01;
            fill.slider = curLength
        }
        if (curLength >= 1) {
            clearInterval(id);
            cc.director.loadScene(sceneName);
        }
    }, 10);

    var onLoaded = function (err) {
        if (err) cc.error(err);
        console.log('Resources load complete.');
    };
    cc.director.preloadScene(sceneName, onProgress, onLoaded);
}

scene.preload = createProgressBar;
module.exports = scene;